---
title: Create a new CNI object
---

[Skip to content](#_top)

[API Reference](https://developers.cloudflare.com/api/go)

[Network Interconnects](https://developers.cloudflare.com/api/go/resources/network_interconnects)

[CNIs](https://developers.cloudflare.com/api/go/resources/network_interconnects/subresources/cnis)

Copy Markdown

Open in **Claude**Open in **ChatGPT**Open in **Cursor**

---

**Copy Markdown****View as Markdown**

# Create a new CNI object

client.NetworkInterconnects.CNIs.New(ctx, params) (\*[CNINewResponse](<https://developers.cloudflare.com/api/go/resources/network_interconnects#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)>), error)

POST/accounts/{account\_id}/cni/cnis

Creates a new Cloud Network Interconnect (CNI) for private network connectivity between Cloudflare and your infrastructure. CNIs enable dedicated, high-performance network links.

##### Security

<details>

<summary>API Token</summary>



The preferred authorization scheme for interacting with the Cloudflare API. <a href="https://developers.cloudflare.com/fundamentals/api/get-started/create-token/">Create a token</a>.

**Example:**<code>Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY</code>

</details>

<details>

<summary>API Email + API Key</summary>



The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

**Example:**<code>X-Auth-Email: user@example.com</code>

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

**Example:**<code>X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194</code>

</details>

##### Accepted Permissions (at least one required)

`Magic WAN Write``Magic Transit Write`

##### ParametersExpand Collapse

<details>

<summary>

params CNINewParams

</summary>

AccountID param.Field\[string]

Path param: Customer account tag

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20account_id">Link to this property</a>

Account param.Field\[string]

Body param: Customer account tag

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20account">Link to this property</a>

Interconnect param.Field\[string]

Body param

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20interconnect">Link to this property</a>

<details>

<summary>

Magic param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/network_interconnects/subresources/cnis/methods/create#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20magic%20%3E%20(schema)">CNINewParamsMagic</a>]

Body param

</summary>

ConduitName string

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20magic%20%3E%20(schema)%20%3E%20(property)%20conduit_name">Link to this property</a>

Description string

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20magic%20%3E%20(schema)%20%3E%20(property)%20description">Link to this property</a>

Mtu int64

formatint32

minimum0

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20magic%20%3E%20(schema)%20%3E%20(property)%20mtu">Link to this property</a>

</details>

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20magic">Link to this property</a>

<details>

<summary>

BGP param.Field\[<a href="https://developers.cloudflare.com/api/go/resources/network_interconnects/subresources/cnis/methods/create#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20bgp%20%3E%20(schema)">CNINewParamsBGP</a>]Optional

Body param

</summary>

CustomerASN int64

ASN used on the customer end of the BGP session

formatint32

minimum0

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20bgp%20%3E%20(schema)%20%3E%20(property)%20customer_asn">Link to this property</a>

ExtraPrefixes \[]string

Extra set of static prefixes to advertise to the customer’s end of the session

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20bgp%20%3E%20(schema)%20%3E%20(property)%20extra_prefixes">Link to this property</a>

Md5Key stringOptional

MD5 key to use for session authentication.

Note that *this is not a security measure*. MD5 is not a valid security mechanism, and the key is not treated as a secret value. This is *only* supported for preventing misconfiguration, not for defending against malicious attacks.

The MD5 key, if set, must be of non-zero length and consist only of the following types of character:

- ASCII alphanumerics: <code>[a-zA-Z0-9]</code>
- Special characters in the set <code>'!@#$%^&amp;*()+[]{}&lt;&gt;/.,;:_-~</code>= |\`

In other words, MD5 keys may contain any printable ASCII character aside from newline (0x0A), quotation mark (<code>"</code>), vertical tab (0x0B), carriage return (0x0D), tab (0x09), form feed (0x0C), and the question mark (<code>?</code>). Requests specifying an MD5 key with one or more of these disallowed characters will be rejected.

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20bgp%20%3E%20(schema)%20%3E%20(property)%20md5_key">Link to this property</a>

</details>

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default%20%3E%20(param)%20bgp">Link to this property</a>

</details>

[Link to this property](<#(resource)%20network_interconnects.cnis%20%3E%20(method)%20create%20%3E%20(params)%20default>)

##### ReturnsExpand Collapse

<details>

<summary>

type CNINewResponse struct{…}

</summary>

ID string

formatuuid

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20id">Link to this property</a>

Account string

Customer account tag

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20account">Link to this property</a>

CustIP string

Customer end of the point-to-point link

This should always be inside the same prefix as <code>p2p_ip</code>.

formatA.B.C.D/N

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20cust_ip">Link to this property</a>

Interconnect string

Interconnect identifier hosting this CNI

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20interconnect">Link to this property</a>

<details>

<summary>

Magic CNINewResponseMagic

</summary>

ConduitName string

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20magic%20%3E%20(property)%20conduit_name">Link to this property</a>

Description string

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20magic%20%3E%20(property)%20description">Link to this property</a>

Mtu int64

formatint32

minimum0

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20magic%20%3E%20(property)%20mtu">Link to this property</a>

</details>

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20magic">Link to this property</a>

P2pIP string

Cloudflare end of the point-to-point link

formatA.B.C.D/N

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20p2p_ip">Link to this property</a>

<details>

<summary>

BGP CNINewResponseBGPOptional

</summary>

CustomerASN int64

ASN used on the customer end of the BGP session

formatint32

minimum0

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20bgp%20%3E%20(property)%20customer_asn">Link to this property</a>

ExtraPrefixes \[]string

Extra set of static prefixes to advertise to the customer’s end of the session

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20bgp%20%3E%20(property)%20extra_prefixes">Link to this property</a>

Md5Key stringOptional

MD5 key to use for session authentication.

Note that *this is not a security measure*. MD5 is not a valid security mechanism, and the key is not treated as a secret value. This is *only* supported for preventing misconfiguration, not for defending against malicious attacks.

The MD5 key, if set, must be of non-zero length and consist only of the following types of character:

- ASCII alphanumerics: <code>[a-zA-Z0-9]</code>
- Special characters in the set <code>'!@#$%^&amp;*()+[]{}&lt;&gt;/.,;:_-~</code>= |\`

In other words, MD5 keys may contain any printable ASCII character aside from newline (0x0A), quotation mark (<code>"</code>), vertical tab (0x0B), carriage return (0x0D), tab (0x09), form feed (0x0C), and the question mark (<code>?</code>). Requests specifying an MD5 key with one or more of these disallowed characters will be rejected.

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20bgp%20%3E%20(property)%20md5_key">Link to this property</a>

</details>

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20bgp">Link to this property</a>

<details>

<summary>

BGPMode CNINewResponseBGPModeOptional

The BGP mode for a CNI. One of the following:

- <code>dynamic_route_exchange</code>
- <code>advertise_only</code>

</summary>

One of the following:

const CNINewResponseBGPModeDynamicRouteExchange CNINewResponseBGPMode = "dynamic\_route\_exchange"

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20bgp_mode%20%3E%20(member)%200">Link to this property</a>

const CNINewResponseBGPModeAdvertiseOnly CNINewResponseBGPMode = "advertise\_only"

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20bgp_mode%20%3E%20(member)%201">Link to this property</a>

</details>

<a href="#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)%20%3E%20(property)%20bgp_mode">Link to this property</a>

</details>

[Link to this property](<#(resource)%20network_interconnects.cnis%20%3E%20(model)%20CNINewResponse%20%3E%20(schema)>)

### Create a new CNI object

Go

HTTPTypeScriptPythonGoTerraform

```
package main

import (
  "context"
  "fmt"

  "github.com/cloudflare/cloudflare-go"
  "github.com/cloudflare/cloudflare-go/network_interconnects"
  "github.com/cloudflare/cloudflare-go/option"
)

func main() {
  client := cloudflare.NewClient(
    option.WithAPIToken("Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY"),
  )
  cni, err := client.NetworkInterconnects.CNIs.New(context.TODO(), network_interconnects.CNINewParams{
    AccountID: cloudflare.F("account_id"),
    Account: cloudflare.F("account"),
    Interconnect: cloudflare.F("interconnect"),
    Magic: cloudflare.F(network_interconnects.CNINewParamsMagic{
      ConduitName: cloudflare.F("conduit_name"),
      Description: cloudflare.F("description"),
      Mtu: cloudflare.F(int64(0)),
    }),
  })
  if err != nil {
    panic(err.Error())
  }
  fmt.Printf("%+v\n", cni.ID)
}
```

200 example

```
{
  "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "account": "account",
  "cust_ip": "192.168.3.4/31",
  "interconnect": "interconnect",
  "magic": {
    "conduit_name": "conduit_name",
    "description": "description",
    "mtu": 0
  },
  "p2p_ip": "192.168.3.4/31",
  "bgp": {
    "customer_asn": 0,
    "extra_prefixes": [
      "192.168.3.4/31"
    ],
    "md5_key": "md5_key"
  },
  "bgp_mode": "dynamic_route_exchange"
}
```

##### Returns Examples

200 example

```
{
  "id": "182bd5e5-6e1a-4fe4-a799-aa6d9a6ab26e",
  "account": "account",
  "cust_ip": "192.168.3.4/31",
  "interconnect": "interconnect",
  "magic": {
    "conduit_name": "conduit_name",
    "description": "description",
    "mtu": 0
  },
  "p2p_ip": "192.168.3.4/31",
  "bgp": {
    "customer_asn": 0,
    "extra_prefixes": [
      "192.168.3.4/31"
    ],
    "md5_key": "md5_key"
  },
  "bgp_mode": "dynamic_route_exchange"
}
```